import type Openai from "openai";
import type { Ty } from "./types/mod.js";
export interface ResponseFormat<T> {
    (template: TemplateStringsArray, ...quasis: Array<string>): ResponseFormat<T>;
    type: "json_schema";
    /** The desired return type in JSON Schema. */
    json_schema: Openai.ResponseFormatJSONSchema["json_schema"];
    /** Transform the content of the first choice into a typed object. */
    into(completion: ChatCompletion): T;
}
export declare function ResponseFormat<T>(name: string, ty: Ty<T, never, true>): ResponseFormat<T>;
export declare namespace ResponseFormat {
    function unwrapFirstChoice(completion: ChatCompletion): string;
    function unwrapChoices(completions: ChatCompletion): string[];
}
export declare class ResponseFormatUnwrapError extends Error {
    readonly name = "UnwrapResponseError";
}
type ChatCompletion = Openai.Chat.ChatCompletion;
export {};
//# sourceMappingURL=ResponseFormat.d.ts.map