import type { Schema, Ty } from "./types/mod.js";
export declare function Tool<T>(name: string, ty: Ty<T, never, true>): Tool<T>;
export interface Tool<T = any> {
    (template: TemplateStringsArray, ...quasis: Array<string>): Tool<T>;
    type: "function";
    /** The name with which OpenAI recognizes the tool. */
    name: string;
    /** A description to inform the LLM of when/how to use the tool. */
    description?: string;
    /** The tool implementation's argument type in JSON Schema. */
    parameters?: Schema;
}
//# sourceMappingURL=Tool.d.ts.map