import { recombine } from "./util/recombine.js";
export function Tool(name, ty) {
    return Tool_(name, ty);
}
function Tool_(name, ty, description) {
    return Object.assign((template, ...quasis) => Tool_(name, ty, description ? `${description} ${recombine(template, quasis)}` : undefined), {
        type: "function",
        name,
        description,
        parameters: ty.schema(),
        toJson() {
            const { type, name, description, parameters } = this;
            return { type, name, description, parameters };
        },
    });
}
//# sourceMappingURL=Tool.js.map