export interface Ty<T = any, P extends keyof any = keyof any, R extends boolean = boolean> {
    <P2 extends Array<keyof any>>(template: TemplateStringsArray, ...placeheld: P2): Ty<T, P | P2[number], R>;
    /** The native TypeScript type. The runtime value is nonexistent. */
    T: T;
    /** The literal types of the placeheld keys. The runtime value is nonexistent. */
    P: P;
    "": {
        subschema: Subschema;
        root: R;
        transform: (value: any) => any;
        context: Array<Context>;
        applied: Applied;
    };
    /** Inject context into that which is placeheld. */
    fill: <A extends Partial<Record<P, number | string>>>(values: A) => Ty<T, Exclude<P, keyof A>, R>;
    /** Get the corresponding JSON Schema. */
    schema(this: Ty<T, never>): Schema;
}
export declare function Ty<T, P extends keyof any, R extends boolean, I = T>(subschema: Subschema, root: R, transform?: (value: I) => T, context?: Array<Context>, applied?: Applied): Ty<T, P, R>;
export type Subschema = (subschema: SubschemaFactory) => Schema;
export type SubschemaFactory = (ty: Ty) => Schema;
export declare function SubschemaFactory(applied: Applied): SubschemaFactory;
interface Context {
    template: TemplateStringsArray;
    placeheld: Array<keyof any>;
}
type Applied = Record<keyof any, number | string>;
export type Schema = Record<string, unknown>;
export {};
//# sourceMappingURL=Ty.d.ts.map