import { recombine } from "../util/recombine.js";
export function Ty(subschema, root, transform = (value) => value, context = [], applied = {}) {
    return Object.assign((template, ...placeheld) => Ty(subschema, root, transform, [{ template, placeheld }, ...context], applied), {}, {
        "": {
            subschema,
            root,
            transform,
            context,
            applied,
        },
        fill: (values) => {
            return Ty(subschema, root, transform, context, {
                ...applied,
                ...values,
            });
        },
        schema() {
            return SubschemaFactory({})(this);
        },
    });
}
export function SubschemaFactory(applied) {
    return (ty) => {
        applied = { ...applied, ...ty[""].applied };
        const description = ty[""].context
            .map(({ template, placeheld }) => recombine(template, placeheld.map((k) => applied[k])))
            .join(" ");
        return {
            ...ty[""].subschema(SubschemaFactory(applied)),
            ...description ? { description } : {},
        };
    };
}
//# sourceMappingURL=Ty.js.map